Subject: Re: [PATCH 0/6] mvneta: SGMII-based in-band link state signaling

From: Stas Sergeev <[email-masked]>
Date: Fri, 27 Mar 2015 16:52:57 +0300

27.03.2015 16:39, Andrew Lunn пишет:
> On Fri, Mar 27, 2015 at 04:28:28PM +0300, Stas Sergeev wrote:
>> Hello.
>>
>> Currently the fixed-link DT binding is pre-configured and
>> cannot be changed in run-time. This means the cable unplug
>> events are not being detected, and the link parameters can't
>> be negotiated.
> 
> O.K, i will ask the dumb question....
> 
> Isn't fixed-link supposed to be used for links which are fixed?
> Why would a fixed-link change?
Hi, my current understanding of fixed-link DT binding is that
it is actually just an MDIO-less link, but not more fixed than that.
I made a patch out of that assumption.
Why I think that way is because fixed-link internally uses a fixed_phy
driver - the one that actually allows a state updates and emulates MDIO
on top of these. So I just exploited that already coded capability.
I think any other approach will require much more work.

> The use cases i've seen for this is when you are connecting the MAC to
> a Switch. The link is configured to its fastest mode and then left
> alone.
> 
> Please could you give some more background information. What do you
> have on the other end of this fixed link which keeps changing?
> Obviously not a switch.
Normal PHY, not a switch.
But there is no MDIO, because SGMII AFAIK doesn't need MDIO.
SGMII has in-band status, but for some reason it seems currently
linux is not ready for such setup - this is what my patch addresses.
Or maybe I am missing something?